<?php
if (!defined('LOG_FILENAME')) {
  define('LOG_FILENAME', 'debug');
}
if (!defined('LOG_DIR')) {
  define('LOG_DIR', '/tmp');
}

/*
   //  Log::getInstance()->debug($query);

 */
class Log
{
    protected $filename, $format, $fh;
    protected static $instance;

    public function __construct($filename, $log_dir) {
        $this->filename = sprintf('%s/%s_%s', $log_dir, $filename, date('Y_m_d'));

        /* date('c') - level - message - page */
        $this->format = '%s - %s - %s - %s';

        if (!file_exists($this->filename)) {
            $this->fh = fopen($this->filename, "w+");
        } else {
            $this->fh = fopen($this->filename, "a+");
        }
    }

    private function getIp() {
        if (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
            return $_SERVER['HTTP_X_FORWARDED_FOR'];
        } else {
            return $_SERVER['REMOTE_ADDR'];
        }
    }

    public static function getInstance() {
        if (!isset(self::$instance)) {
            self::$instance = new Log(LOG_FILENAME, LOG_DIR);
        }
        return self::$instance;
    }

    public function setFormat($format) {
        if (!empty($format)) {
            $this->format = $format;
        }
    }

    public function info() {
        $this->addMessage('info', func_get_args());
    }

    public function warning() {
        $this->addMessage('warning', func_get_args());
    }

    public function debug() {
        $this->addMessage('debug', func_get_args());
    }

    public function critical() {
        $this->addMessage('critical', func_get_args());
    }

    private function addMessage() {
        $args = func_get_args();
        if (count($args)<2) {
            throw new Exception('Au minimum level et message comme arguments');
        }
        $level = array_shift($args);
        $chaine = '';

        foreach ($args[0] as $message) {
            if (is_array($message) or is_object($message)) {
                $fmt_message = print_r($message, true);
            } else {
                $fmt_message = $message;
            }

            $chaine .= sprintf(
                $this->format."\n",
                date('c'),
                $level,
                $fmt_message,
                isset($_SERVER['REQUEST_URI'])?$_SERVER['REQUEST_URI']:''
            );
        }
        
        if (flock($this->fh, LOCK_EX)) {
            if (fseek($this->fh, 0, SEEK_END)===0) {
                if (!fputs($this->fh, $chaine)) {
                    flock($this->fh, LOCK_UN);
                    throw new FileException('Probleme avec fputs');
                }
                flock($this->fh, LOCK_UN);
            } else {
                flock($this->fh, LOCK_UN);
                throw new FileException('Probleme avec fseek');
            }
        }
    }
}
